//+------------------------------------------------------------------+
//|                                            II_PipAccumulator.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2


#property indicator_chart_window
extern string probp = "== Alert Probability Levels ==";
extern int ProbLevelLong = 20;
extern int ProbLevelShort = -20;
extern string alertp = "== Alert Parameters ==";
extern bool AlertArrow = false;
extern bool AlertArrowProb = false;
extern bool AlertProb = false;
extern string renkop = "== Renko Settings ==";
extern bool UseRenko = false;
extern int  DefaultTF = 5;
extern string macdp = "== MACD Parameters ==";
extern int fast_ema = 24;
extern int slow_ema = 52;
extern int macd_sma = 18;
extern int macd_applyto = 0;
extern string txd = "== Text Display Parameters ==";
extern bool WriteAccInfo = false;
extern bool WriteFlags = true;
extern int font_size = 8;
extern int VPos = 50;
extern int HPos = 50;
extern string font = "Arial";
extern color text_color = Black;
extern color dn_box_color = PaleVioletRed;
extern color up_box_color = PaleGreen;
extern string inp = "== Indicators Percentage ==";
extern double MACD_Per = 25;
extern double SAR_Per = 25;
extern double RSI_Per = 10;
extern double STOCH_Per = 10;
extern double SMA1_Per = 10;
extern double EMA1_Per = 10;
extern double EMA2_Per = 10;
extern string imdp = "== Indicators MACD Parameters ==";
extern int MACD_fastEMA = 12;
extern int MACD_slowEMA = 26;
extern int MACD_SMA = 9;
extern string isrp = "== Indicators SAR Parameters ==";
extern double SAR_step = 0.02;
extern double SAR_maximum = 0.2;
extern string irsip = "== Indicators RSI Parameters ==";
extern int RSI_period = 14;
extern string ishp = "== Indicators STOCH Parameters ==";
extern int STOCH_kPeriod = 5;
extern int STOCH_dPeriod = 3;
extern int STOCH_slowing = 3;
extern string imap = "== Indicators MA Parameters ==";
extern int SMA1_period = 21;
extern int SMA1_shift = 0;
extern int SMA1_method = 0;
extern int SMA1_applyTo = 0;
extern int EMA1_period = 52;
extern int EMA1_shift = 0;
extern int EMA1_method = 1;
extern int EMA1_applyTo = 0;
extern int EMA2_period = 104;
extern int EMA2_shift = 0;
extern int EMA2_method = 1;
extern int EMA2_applyTo = 0;
extern string lbp = "== Look back period ==";
extern int  LookBackPeriod = 1000;        

int DigitsV;
double PointsV;
double BoxMACD_Main;
double BoxMACD_Signal;
double MACD_Main[10];
double MACD_Signal[10];
double SAR[10];
double RSI[10];
double Stoch_Main[10];
double Stoch_Signal[10];
double SMA1[10];
double EMA1[10];
double EMA2[10];
double BoxBuy[];
double BoxSell[];
int Signal_MACD[10];
int Signal_SAR[10];
int Signal_RSI[10];
int Signal_Stoch[10];
int Signal_SMA1[10];
int Signal_EMA1[10];
int Signal_EMA2[10];
bool BoxBuyFlag=false;
bool BoxSellFlag=false;
bool BuyActive=false;
bool SellActive=false;
bool BuyAlert=false;
bool SellAlert=false;
datetime t1;
datetime t2;
double p1;
double p2;
double HH;
double LL;
double MasterProb;
int ctr;
int CandleNo;
bool BuyArrow;
bool SellArrow;
bool BuyArrowProb;
bool SellArrowProb;
bool BuyProb;
bool SellProb;
int M1TFWeights[8] = {55, 25, 13, 7, 0, 0, 0, 0, 0};     //M1
int M5TFWeights[8] = {15, 50, 25, 15, 0, 0, 0, 0, 0};    //M5
int M15TFWeights[8] = {7, 15, 41, 20, 10, 7, 0, 0, 0};    //M15
int M30TFWeights[8] = {3, 7, 20, 40, 20, 7, 3, 0, 0};     //M30
int H1TFWeights[8] = {3, 7, 10, 20, 40, 10, 7, 3, 0};    //H1
int H4TFWeights[8] = {0, 3, 7, 10, 20, 40, 10, 7, 3};    //H4
int D1TFWeights[8] = {0, 0, 0, 0, 5, 22, 46, 22, 5};     //D1
int W1TFWeights[8] = {0, 0, 0, 0, 0, 10, 18, 50, 22};    //W1
int MN1TFWeights[8] = {0, 0, 0, 0, 0, 0, 10, 20, 70};     //MN1


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {

   Initialise();

   SetIndexBuffer(0, BoxBuy);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexEmptyValue(0, EMPTY_VALUE);
   SetIndexLabel(0, "BuyBox");
   SetIndexBuffer(1, BoxSell);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexEmptyValue(1, EMPTY_VALUE);
   SetIndexLabel(1, "SellBox");
  
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
   Initialise();
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  Initialise();

  for (int i=LookBackPeriod; i>CandleNo; i--) {
      CalculateSignals(i);
  }
  
  ReadIndicators();
  CalcMasterProbability();
  WriteText();
}


void CalculateSignals(int i) {

BoxMACD_Main = iMACD(NULL,0,fast_ema,slow_ema,macd_sma,macd_applyto,MODE_MAIN,i);
BoxMACD_Signal = iMACD(NULL,0,fast_ema,slow_ema,macd_sma,macd_applyto,MODE_SIGNAL,i);
BoxBuy[i] = 0;
BoxSell[i] = 0;

if (BoxMACD_Main > BoxMACD_Signal && !BoxBuyFlag && BoxMACD_Signal != 0) {
    BoxBuy[i] = iLow(NULL,0,i) - iATR(Symbol(), Period(), 60, i) / 1.5;
    BoxBuyFlag = true;
    BoxSellFlag = false;   
    if (AlertArrow && BuyArrow != Time[0] && i == 1 && !BuyAlert) {
        BuyArrow = Time[0];
        BuyAlert = true;
        SellAlert = false;
        Alert("Buy Arrow, " + Symbol() + ", " + TimeToStr(Time[0]));
    }
}

if (BoxMACD_Main < BoxMACD_Signal && !BoxSellFlag && BoxMACD_Main != 0) {
    BoxSell[i] = iHigh(NULL,0,i) + iATR(Symbol(), Period(), 60, i) / 1.5;
    BoxBuyFlag = false;
    BoxSellFlag = true;   
    if (AlertArrow && SellArrow != Time[0] && i == 1 && !SellAlert) {
        SellArrow = Time[0];
        SellAlert = true;
        BuyAlert = false;
        Alert("Sell Arrow, " + Symbol() + ", " + TimeToStr(Time[0]));
    }
}


if (AlertArrowProb && MasterProb > ProbLevelLong && BuyArrowProb != Time[0] &&
    BoxBuyFlag && i == 1 && !BuyAlert) {
    BuyArrowProb = Time[0];
    BuyAlert = true;
    SellAlert = false;
    Alert("Buy Arrow/Prob > ", ProbLevelLong, ", " + Symbol() + ", " + TimeToStr(Time[0]));
}

if (AlertArrowProb && MasterProb < ProbLevelShort && SellArrowProb != Time[0] &&
    BoxSellFlag && i == 1 && !SellAlert) {
    SellArrowProb = Time[0];
    SellAlert = true;
    BuyAlert = false;
    Alert("Sell Arrow/Prob < ", + ProbLevelShort, ", ", Symbol() + ", " + TimeToStr(Time[0]));
}

if (AlertProb && MasterProb > ProbLevelLong && BuyProb != Time[0] &&
    i == 1 && !BuyAlert) {
    BuyProb = Time[0];
    BuyAlert = true;
    SellAlert = false;
    Alert("Buy Prob > ", ProbLevelLong, ", " + Symbol() + ", " + TimeToStr(Time[0]));
}

if (AlertProb && MasterProb < ProbLevelShort && SellProb != Time[0] &&
    i == 1 && !SellAlert) {
    SellProb = Time[0];
    SellAlert = true;
    BuyAlert = false;
    Alert("Sell Prob < ", + ProbLevelShort, ", ", Symbol() + ", " + TimeToStr(Time[0]));
}


if (iHigh(NULL,0,i) > HH) HH = iHigh(NULL,0,i);
if (iLow(NULL,0,i) < LL) LL = iLow(NULL,0,i);

if (BoxBuy[i] > 0) {
   BuyActive=true;
   t1 = iTime(NULL,0,i);
}   
if (BoxSell[i] > 0) {
   SellActive=true;
   t2 = iTime(NULL,0,i);
}   

if (BuyActive && BoxSell[i] > 0) { 
//  Print("t1 = ", TimeToStr(t1), "p1 = ", p1, "t2 = ", TimeToStr(t2), "p2 = ", p2);
  ObjectCreate("Box_" + ctr, OBJ_RECTANGLE, 0, t2,HH, t1,LL);
  ObjectSet("Box_" + ctr, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet("Box_" + ctr, OBJPROP_COLOR, up_box_color);
  ObjectSet("Box_" + ctr, OBJPROP_BACK, True);
  BuyActive=false;
  HH = 0;
  LL = 9999;
  ctr = ctr + 1;
}

if (SellActive && BoxBuy[i] > 0) { 
//  Print("t1 = ", TimeToStr(t1), "LL = ", LL, "t2 = ", TimeToStr(t2), "HH = ", HH);
  ObjectCreate("Box_" + ctr, OBJ_RECTANGLE, 0, t1,LL, t2,HH);
  ObjectSet("Box_" + ctr, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet("Box_" + ctr, OBJPROP_COLOR, dn_box_color);
  ObjectSet("Box_" + ctr, OBJPROP_BACK, True);
  SellActive=false;
  HH = 0;
  LL = 9999;
  ctr = ctr + 1;
}


}

void ReadIndicators() {
int j;
int period;
int ChartTF; 

for (j=0; j<9; j++) {
 Signal_MACD[j] = 0;
 Signal_SAR[j] = 0;
 Signal_RSI[j] = 0;
 Signal_Stoch[j] = 0;
 Signal_SMA1[j] = 0;
 Signal_EMA1[j] = 0;
 Signal_EMA2[j] = 0;
}

for (j=0; j<9; j++) {

    if (j==0) period = PERIOD_M1;
    if (j==1) period = PERIOD_M5;
    if (j==2) period = PERIOD_M15;
    if (j==3) period = PERIOD_M30;
    if (j==4) period = PERIOD_H1;
    if (j==5) period = PERIOD_H4;
    if (j==6) period = PERIOD_D1;
    if (j==7) period = PERIOD_W1;
    if (j==8) period = PERIOD_MN1;   
    
    MACD_Main[j] = iMACD(NULL,period,MACD_fastEMA,MACD_slowEMA,MACD_SMA,0,MODE_MAIN,CandleNo);
    MACD_Signal[j] = iMACD(NULL,period,MACD_fastEMA,MACD_slowEMA,MACD_SMA,0,MODE_SIGNAL,CandleNo);
    SAR[j] = iSAR(NULL,period,SAR_step,SAR_maximum,CandleNo);
    RSI[j] = iRSI(NULL,period,RSI_period,PRICE_CLOSE,CandleNo);
    Stoch_Main[j] = iStochastic(NULL,period,STOCH_kPeriod,STOCH_dPeriod,STOCH_slowing,MODE_SMA,0,MODE_MAIN,CandleNo);
    Stoch_Signal[j] = iStochastic(NULL,period,STOCH_kPeriod,STOCH_dPeriod,STOCH_slowing,MODE_SMA,0,MODE_SIGNAL,CandleNo);
    SMA1[j] = iMA(NULL,period,SMA1_period,SMA1_shift,SMA1_method,SMA1_applyTo,CandleNo);
    EMA1[j] = iMA(NULL,period,EMA1_period,EMA1_shift,EMA1_method,EMA1_applyTo,CandleNo);
    EMA2[j] = iMA(NULL,period,EMA2_period,EMA2_shift,EMA2_method,EMA2_applyTo,CandleNo);

   if (MACD_Main[j] > MACD_Signal[j]) Signal_MACD[j] = 1;
   if (MACD_Main[j] < MACD_Signal[j]) Signal_MACD[j] = -1;
   if (SAR[j] < Open[0]) Signal_SAR[j] = 1;
   if (SAR[j] > Open[0]) Signal_SAR[j] = -1;
   if (RSI[j] < 35) Signal_RSI[j] = 1;
   if (RSI[j] > 65) Signal_RSI[j] = -1;
   if (Stoch_Main[j] < 35) Signal_Stoch[j] = 1;
   if (Stoch_Main[j] > 65) Signal_Stoch[j] = -1;
   if (Low[SMA1_shift] > SMA1[j]) Signal_SMA1[j] = 1;
   if (High[SMA1_shift] < SMA1[j]) Signal_SMA1[j] = -1;
   if (EMA1[j] < SMA1[j]) Signal_EMA1[j] = 1;
   if (EMA1[j] > SMA1[j]) Signal_EMA1[j] = -1;
   if (EMA1[j] < EMA2[j]) Signal_EMA2[j] = 1;
   if (EMA1[j] > EMA2[j]) Signal_EMA2[j] = -1;

}

if (UseRenko) 
   ChartTF = DefaultTF;
else   
   ChartTF = Period();

if (ChartTF == PERIOD_M1 || ChartTF == PERIOD_M5) {
   for (j=4; j<9; j++) {   
        Signal_MACD[j] = 0;        
        Signal_SAR[j] = 0;        
        Signal_RSI[j] = 0;        
        Signal_Stoch[j] = 0;        
        Signal_SMA1[j] = 0;        
        Signal_EMA1[j] = 0;        
        Signal_EMA2[j] = 0;                                                        
   }
} 

if (ChartTF == PERIOD_M15) {
   for (j=6; j<9; j++) {   
        Signal_MACD[j] = 0;        
        Signal_SAR[j] = 0;        
        Signal_RSI[j] = 0;        
        Signal_Stoch[j] = 0;        
        Signal_SMA1[j] = 0;        
        Signal_EMA1[j] = 0;        
        Signal_EMA2[j] = 0;                                                        
   }
} 

if (ChartTF == PERIOD_M30) {
   for (j=7; j<9; j++) {   
        Signal_MACD[j] = 0;        
        Signal_SAR[j] = 0;        
        Signal_RSI[j] = 0;        
        Signal_Stoch[j] = 0;        
        Signal_SMA1[j] = 0;        
        Signal_EMA1[j] = 0;        
        Signal_EMA2[j] = 0;                                                        
   }
} 

if (ChartTF == PERIOD_H1) {
   for (j=8; j<9; j++) {   
        Signal_MACD[j] = 0;        
        Signal_SAR[j] = 0;        
        Signal_RSI[j] = 0;        
        Signal_Stoch[j] = 0;        
        Signal_SMA1[j] = 0;        
        Signal_EMA1[j] = 0;        
        Signal_EMA2[j] = 0;                                                        
   }
} 

if (ChartTF == PERIOD_H4) {
   for (j=0; j<1; j++) {   
        Signal_MACD[j] = 0;        
        Signal_SAR[j] = 0;        
        Signal_RSI[j] = 0;        
        Signal_Stoch[j] = 0;        
        Signal_SMA1[j] = 0;        
        Signal_EMA1[j] = 0;        
        Signal_EMA2[j] = 0;                                                        
   }
} 

if (ChartTF == PERIOD_D1) {
   for (j=0; j<4; j++) {   
        Signal_MACD[j] = 0;        
        Signal_SAR[j] = 0;        
        Signal_RSI[j] = 0;        
        Signal_Stoch[j] = 0;        
        Signal_SMA1[j] = 0;        
        Signal_EMA1[j] = 0;        
        Signal_EMA2[j] = 0;                                                        
   }
} 

if (ChartTF == PERIOD_W1) {
   for (j=0; j<5; j++) {   
        Signal_MACD[j] = 0;        
        Signal_SAR[j] = 0;        
        Signal_RSI[j] = 0;        
        Signal_Stoch[j] = 0;        
        Signal_SMA1[j] = 0;        
        Signal_EMA1[j] = 0;        
        Signal_EMA2[j] = 0;                                                        
   }
} 

if (ChartTF == PERIOD_MN1) {
   for (j=0; j<6; j++) {   
        Signal_MACD[j] = 0;        
        Signal_SAR[j] = 0;        
        Signal_RSI[j] = 0;        
        Signal_Stoch[j] = 0;        
        Signal_SMA1[j] = 0;        
        Signal_EMA1[j] = 0;        
        Signal_EMA2[j] = 0;                                                        
   }
}


}




void CalcMasterProbability() {
double MACDProb;
double SARProb;
double RSIProb;
double StochProb;
double SMA1Prob;
double EMA1Prob;
double EMA2Prob;
double TFWeight;
int TotalTFs;
double PercMult = 0.01;
int ChartTF;

MasterProb = 0;

if (UseRenko) 
   ChartTF = DefaultTF;
else   
   ChartTF = Period();


for (int j=0; j<9; j++) {

   if (ChartTF == PERIOD_M1) TFWeight = M1TFWeights[j];
   if (ChartTF == PERIOD_M5) TFWeight = M5TFWeights[j];
   if (ChartTF == PERIOD_M15) TFWeight = M15TFWeights[j];
   if (ChartTF == PERIOD_M30) TFWeight = M30TFWeights[j];
   if (ChartTF == PERIOD_H1) TFWeight = H1TFWeights[j];
   if (ChartTF == PERIOD_H4) TFWeight = H4TFWeights[j];
   if (ChartTF == PERIOD_D1) TFWeight = D1TFWeights[j];
   if (ChartTF == PERIOD_W1) TFWeight = W1TFWeights[j];
   if (ChartTF == PERIOD_MN1) TFWeight = MN1TFWeights[j];
   
   MACDProb = Signal_MACD[j] * MACD_Per * TFWeight * PercMult;
   SARProb = Signal_SAR[j] * SAR_Per * TFWeight * PercMult;
   RSIProb = Signal_RSI[j] * RSI_Per * TFWeight * PercMult;
   StochProb = Signal_Stoch[j] * STOCH_Per * TFWeight * PercMult;
   SMA1Prob = Signal_SMA1[j] * SMA1_Per * TFWeight * PercMult;
   EMA1Prob = Signal_EMA1[j] * EMA1_Per * TFWeight * PercMult;
   EMA2Prob = Signal_EMA2[j] * EMA2_Per * TFWeight * PercMult;

   MasterProb = MasterProb + MACDProb + SARProb + RSIProb + StochProb + SMA1Prob + EMA1Prob + EMA2Prob;
 
} 

}

void WriteText() { 
double ATR;
int hpos;
string TFtext;

font_size = 9;
font = "Arial Bold";
TextObj("Probtxt", "Master Prob:", HPos, VPos, text_color, font, font_size);
TextObj("Prob", DoubleToStr(MasterProb,0), HPos+100, VPos, text_color, font, font_size);
font_size = 8;
font = "Arial";
TextObj("ATRtxt", "Current ATR(12):", HPos, VPos+14, text_color, font, font_size);
ATR = iATR(NULL,0,12,1);
TextObj("ATR", DoubleToStr(ATR,4), HPos+100, VPos+14, text_color, font, font_size);

if (WriteFlags) {
TFtext = "M1  M5  M15 M30 H1  H4   D1  WK  MN";
TextObj("TFtxt",TFtext, HPos+50, VPos+34, text_color, font, font_size);
TextObj("MACD","MACD:", HPos, VPos+48, text_color, font, font_size);
TextObj("RSI","RSI:", HPos, VPos+62, text_color, font, font_size);
TextObj("SAR","SAR:", HPos, VPos+76, text_color, font, font_size);
TextObj("Stoch","Stoch:", HPos, VPos+92, text_color, font, font_size);
TextObj("SMA1","SMA1:", HPos, VPos+104, text_color, font, font_size);
TextObj("EMA1","EMA1:", HPos, VPos+118, text_color, font, font_size);
TextObj("EMA2","EMA2:", HPos, VPos+132, text_color, font, font_size);

hpos = HPos + 30;

for (int j=0;j<9;j++) {

hpos = hpos + 22;

if (Signal_MACD[j] == 1) TextObj("MACD_"+j,CharToStr(110), hpos, VPos+46, Green, "Wingdings",12);
if (Signal_MACD[j] == -1) TextObj("MACD_"+j,CharToStr(110), hpos, VPos+46, Red, "Wingdings",12);
if (Signal_RSI[j] == 1) TextObj("RSI_"+j,CharToStr(110), hpos, VPos+60, Green, "Wingdings",12);
if (Signal_RSI[j] == -1) TextObj("RSI_"+j,CharToStr(110), hpos, VPos+60, Red, "Wingdings",12);
if (Signal_SAR[j] == 1) TextObj("SAR_"+j,CharToStr(110), hpos, VPos+74, Green, "Wingdings",12);
if (Signal_SAR[j] == -1) TextObj("SAR_"+j,CharToStr(110), hpos, VPos+74, Red, "Wingdings",12);
if (Signal_Stoch[j] == 1) TextObj("Stoch_"+j,CharToStr(110), hpos, VPos+90, Green, "Wingdings",12);
if (Signal_Stoch[j] == -1) TextObj("Stoch_"+j,CharToStr(110), hpos, VPos+90, Red, "Wingdings",12);
if (Signal_SMA1[j] == 1) TextObj("SMA1_"+j,CharToStr(110), hpos, VPos+102, Green, "Wingdings",12);
if (Signal_SMA1[j] == -1) TextObj("SMA1_"+j,CharToStr(110), hpos, VPos+102, Red, "Wingdings",12);
if (Signal_EMA1[j] == 1) TextObj("EMA1_"+j,CharToStr(110), hpos, VPos+116, Green, "Wingdings",12);
if (Signal_EMA1[j] == -1) TextObj("EMA1_"+j,CharToStr(110), hpos, VPos+116, Red, "Wingdings",12);
if (Signal_EMA2[j] == 1) TextObj("EMA2_"+j,CharToStr(110), hpos, VPos+130, Green, "Wingdings",12);
if (Signal_EMA2[j] == -1) TextObj("EMA2_"+j,CharToStr(110), hpos, VPos+130, Red, "Wingdings",12);
}

}

}

void TextObj(string objname, string objtext, int hpos, int ypos, color col=Black, string font="Arial", int font_size=8) {

ObjectDelete(objname);                                
ObjectCreate(objname, OBJ_LABEL, 0, 0, 0);
ObjectSetText(objname,objtext,font_size,font,col);          
ObjectSet(objname, OBJPROP_CORNER, 0);
ObjectSet(objname, OBJPROP_XDISTANCE, hpos);
ObjectSet(objname, OBJPROP_YDISTANCE, ypos);                         

}

void Initialise() {
string ObjName;

   int TotObjs = ObjectsTotal();
   for (int i = TotObjs - 1; i >= 0; i--) {
      ObjName = ObjectName(i);
      if (StringSubstr(ObjName,0,4) == "Box_") ObjectDelete(ObjName);
      if (StringSubstr(ObjName,0,4) == "MACD") ObjectDelete(ObjName);         
      if (StringSubstr(ObjName,0,3) == "RSI") ObjectDelete(ObjName);           
      if (StringSubstr(ObjName,0,3) == "SAR") ObjectDelete(ObjName);     
      if (StringSubstr(ObjName,0,5) == "Stoch") ObjectDelete(ObjName);          
      if (StringSubstr(ObjName,0,4) == "SMA1") ObjectDelete(ObjName);            
      if (StringSubstr(ObjName,0,4) == "EMA1") ObjectDelete(ObjName);              
      if (StringSubstr(ObjName,0,4) == "EMA2") ObjectDelete(ObjName);                
   }

  ObjectDelete("Probtxt");  
  ObjectDelete("Prob");    
  ObjectDelete("ATRtxt");   
  ObjectDelete("ATR");     
  ObjectDelete("TFtxt");       
  Comment("");
  ctr = 0;
  LL = 9999;
  HH = 0;
  BuyActive=false;
  SellActive=false;
  BoxBuyFlag=false;
  BoxSellFlag=false;
}